Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.instruct
Class FixedElement

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.instruct.Instruction
              net.sf.saxon.instruct.ParentNodeConstructor
                  net.sf.saxon.instruct.ElementCreator
                      net.sf.saxon.instruct.FixedElement

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, TailCallReturner, InstructionInfoProvider

    public class FixedElement

extends ElementCreator

An instruction that creates an element node whose name is known statically. Used for literal results elements in XSLT, for direct element constructors in XQuery, and for xsl:element in cases where the name and namespace are known statically.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`FixedElement(int nameCode, int[] namespaceCodes, boolean inheritNamespaces, SchemaType schemaType, int validation)` Create an instruction that creates a new element node

Method Summary
`void` | `checkPermittedContents(SchemaType parentType, StaticContext env, boolean whole)` Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type.
`void` | `display(int level, PrintStream out, Configuration config)` Display this instruction as an expression, for diagnostics
`int[]` | `getActiveNamespaces()` Callback to get a list of the intrinsic namespaces that need to be generated for the element.
`InstructionInfo` | `getInstructionInfo()` Get InstructionInfo for this expression
`ItemType` | `getItemType(TypeHierarchy th)` Get the type of the item returned by this instruction
`int` | `getNameCode(XPathContext context)` Callback from the superclass ElementCreator to get the nameCode for the element name
`String` | `getNewBaseURI(XPathContext context)` Get the base URI for the element being constructed
`Expression` | `simplify(StaticContext env)` Simplify an expression.

Methods inherited from class net.sf.saxon.instruct.ElementCreator
`computeSpecialProperties, evaluateItem, getImplementationMethod, isInheritNamespaces, isValidating, processLeavingTail, setValidationMode, suppressValidation`

Methods inherited from class net.sf.saxon.instruct.ParentNodeConstructor
`computeCardinality, createsNewNodes, getBaseURI, getCardinality, getContentExpression, getSchemaType, getValidationMode, isLazyConstruction, isNamespaceSensitive, iterateSubExpressions, optimize, replaceSubExpression, setBaseURI, setContentExpression, setLazyConstruction, setSchemaType, typeCheck`

Methods inherited from class net.sf.saxon.instruct.Instruction
`appendItem, evaluateAsString, getInstructionNameCode, getSourceLocator, isXSLT, iterate, process, promote`

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getIntrinsicDependencies, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, markTailFunctionCalls, resetStaticProperties, setLocationId, setParentExpression, setParentExpression`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface javax.xml.transform.SourceLocator
`getColumnNumber, getLineNumber, getPublicId, getSystemId`

Constructor Detail

### FixedElement

    public FixedElement(int nameCode,
                        int[] namespaceCodes,
                        boolean inheritNamespaces,
                        SchemaType schemaType,
                        int validation)

  Create an instruction that creates a new element node

  Parameters:
    `nameCode` - Represents the name of the element node
    `namespaceCodes` - List of namespaces to be added to the element node. May be null if none are required.
    `inheritNamespaces` - true if the children of this element are to inherit its namespaces
    `schemaType` - Type annotation for the new element node

Method Detail

### getInstructionInfo

    public InstructionInfo getInstructionInfo()

  Description copied from class: `Expression`
  Get InstructionInfo for this expression

  Specified by:
    `getInstructionInfo` in interface `InstructionInfoProvider`
  Overrides:
    `getInstructionInfo` in class `Instruction`

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression).

  Overrides:
    `simplify` in class `ParentNodeConstructor`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### getItemType

    public ItemType getItemType(TypeHierarchy th)

  Get the type of the item returned by this instruction

  Overrides:
    `getItemType` in class `ElementCreator`
  Parameters:
    `th` - The type hierarchy cache
  Returns:
    the item type

### getNameCode

    public int getNameCode(XPathContext context)

  Callback from the superclass ElementCreator to get the nameCode for the element name

  Specified by:
    `getNameCode` in class `ElementCreator`
  Parameters:
    `context` - The evaluation context (not used)
  Returns:
    the name code for the element name

### getNewBaseURI

    public String getNewBaseURI(XPathContext context)

  Description copied from class: `ElementCreator`
  Get the base URI for the element being constructed

  Specified by:
    `getNewBaseURI` in class `ElementCreator`

### checkPermittedContents

    public void checkPermittedContents(SchemaType parentType,
                                       StaticContext env,
                                       boolean whole)
                                throws XPathException

  Check that any elements and attributes constructed or returned by this expression are acceptable in the content model of a given complex type. It's always OK to say yes, since the check will be repeated at run-time. The process of checking element and attribute constructors against the content model of a complex type also registers the type of content expected of those constructors, so the static validation can continue recursively.

  Overrides:
    `checkPermittedContents` in class `Expression`
  Throws:
    `XPathException`

### getActiveNamespaces

    public int[] getActiveNamespaces()

  Callback to get a list of the intrinsic namespaces that need to be generated for the element. The result is an array of namespace codes, the codes either occupy the whole array or are terminated by a -1 entry. A result of null is equivalent to a zero-length array.

  Overrides:
    `getActiveNamespaces` in class `ElementCreator`

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Display this instruction as an expression, for diagnostics

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.